strapper/access/urls.py
# pylint:
from django.urls import path
from . import views

app_name = 'access'

urlpatterns = [
    path('search_users/', views.UserAPIView.as_view(), name='search_users'),
    path('update_app_access/', views.AccessAPIView.as_view(), name='update_app_access'),
    path(
        'email_ownership_transfer_request/',
        views.AccessAPIView.as_view(),
        name='email_ownership_transfer_request'),
    path(
        'accept_ownership_transfer_request/<slug:app_id>/',
        views.TransferOwnershipAPIView.as_view(),
        name='accept_ownership_transfer_request'),
    path(
        'cancel_ownership_transfer_request/<slug:app_id>/',
        views.TransferOwnershipAPIView.as_view(),
        name='cancel_ownership_transfer_request'),
    path(
        'decline_ownership_transfer_request/<slug:app_id>/',
        views.TransferOwnershipAPIView.as_view(),
        name='decline_ownership_transfer_request'),
]

strapper/help/urls.py
# pylint:
from django.urls import path
from . import views

urlpatterns = [
    path('using_strapper', views.UsingStrapperPage.as_view(), name="help_using_strapper"),
    path('about_strap/', views.AboutStrapPage.as_view(), name="help_about_strap"),
]

strapper/normal_users/urls.py
# pylint:
from django.urls import path
from . import views, webhook_views

urlpatterns = [
    # Dashboard
    path('', views.Dashboard.as_view(), name='dashboard'),

    # Landing pages
    path('welcome/', views.WelcomeView.as_view(), name='welcome'),
    path('team/', views.AboutTeam.as_view(), name='about_team'),
    path('notfound/', views.DefaultStrapView.as_view(), name='default_strap'),

    # Applications
    path('<slug:identifier>/', views.ApplicationView.as_view(), name='get_app'),
    path('edit/<slug:identifier>/', views.Dashboard.as_view(), name='edit_app'),
    path('delete/<slug:identifier>/', views.ApplicationDeleteView.as_view(), name='delete_app'),
    path('scan_containers/<slug:identifier>/', views.ApplicationAPIView.as_view(), name='scan_containers_app'),

    # K8s resources
    path('k8s_resources/<slug:identifier>/', views.K8sResourcesView.as_view(), name='update_k8s_resources'),
    path(
        'k8s_resources_request/<slug:identifier>/',
        views.K8sResourcesRequestView.as_view(),
        name='request_k8s_resources'
    ),
    path(
        'k8s_resources_request/cancel/<slug:identifier>/',
        views.K8sResourcesRequestView.as_view(),
        name='cancel_k8s_resource_request'
    ),

    # Containers
    path('container/create/<slug:identifier>/', views.ContainerAPIView.as_view(), name='create_container'),
    path('container/edit/<slug:identifier>/<int:container_id>/', views.ContainerAPIView.as_view(),
        name='edit_container'),
    path('container/delete/<slug:identifier>/<int:container_id>/', views.ContainerAPIView.as_view(),
        name='delete_container'),
    path('container/scan_report/<slug:identifier>/<int:container_id>/', views.ContainerScanReportView.as_view(),
        name='scan_report_container'),
    path('container/scan/<slug:identifier>/<int:container_id>/', views.ContainerScanView.as_view(),
        name='scan_container'),

    # Harbor projects
    path('harbor/create/<slug:identifier>/', views.HarborAPIView.as_view(), name='create_harbor_project'),
    path('harbor/get_images/<slug:identifier>/', views.HarborAPIView.as_view(), name='get_harbor_images'),

    # Groups
    path('group/create/<slug:identifier>/', views.GroupView.as_view(), name='create_group'),
    path('group/create/', views.GroupView.as_view(), name='create_group_to_app'),
    path('group/edit/<slug:identifier>/<int:group_id>/', views.GroupView.as_view(), name='edit_group'),
    path('group/edit/<int:group_id>/', views.GroupView.as_view(), name='edit_group'),
    path('group/delete/<slug:identifier>/<int:group_id>/', views.GroupView.as_view(), name='delete_group'),
    path('group/delete/<int:group_id>/', views.GroupView.as_view(), name='delete_group'),
    path('group/add_groups_to_app/<slug:identifier>/', views.GroupView.as_view(), name='add_groups_to_app'),

    # Deployments
    path('deploy/<slug:identifier>/', views.DeploymentView.as_view(), name='deploy_app'),
    path('deploy_log/<slug:identifier>/', views.DeploymentLogView.as_view(), name='deploy_log_app'),
    path('stop_deploy/<slug:identifier>/', views.StopDeploymentView.as_view(), name='stop_deploy_app'),

    # App logs and terminal
    path('app_log/<slug:identifier>/', views.ApplicationLogView.as_view(), name='app_log'),
    path('terminal/<slug:identifier>/', views.ApplicationTerminalView.as_view(), name='terminal'),


    # API endpoints for apps deployed by STRAP
    path('api/group/get_groups_for_user/<slug:identifier>/', views.GroupAPIView.as_view(), name='get_groups_for_user'),
    path('api/group/get_users_for_group/<slug:identifier>/', views.GroupAPIView.as_view(), name='get_users_for_group'),

    # Non-page urls, helper views/functions
    path('app_info/<slug:identifier>/', views.deployment_app_info_view, name='app_info'),

    # Notifications
    path('notification/<int:notification_id>/', views.NotificationView.as_view(), name='get_notification'),

    # Webhook
    path('webhook/registry/image_pushed/', webhook_views.image_pushed_view, name='webhook_image_pushed'),
    path(
        'webhook/registry/image_high_vulnerabilities/',
        webhook_views.image_high_vulnerabilities_notification,
        name='webhook_image_high_vulnerabilities'
    ),
]

strapper/strapper/urls.py
# pylint:
"""strapper URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from . import auth

urlpatterns = [
    path('admin-django/', admin.site.urls),
    path('login/', auth.LoginView.as_view(), name='login'),
    path('logout/', auth.LogoutView.as_view(), name='logout'),
    path('admin/', include('admin_users.urls'), name='admin_users'),
    path('content/', include('django_editablecontent.urls'), name='editablecontent'),
    path('fileupload/', include('django_fileupload.urls'), name='fileupload'),
    path('help/', include('help.urls'), name='help'),
    path('wizard/', include('wizard.urls'), name='wizard'),
    path('access/', include('access.urls'), name='access'),
    path('', include('normal_users.urls'), name='normal_users'),
]

# Add URL patterns for serving media files during development
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

strapper/normal_users/forms.py
# pylint:
from django import forms
from django.core.validators import RegexValidator
from .models import Application, Container, Group

# Validate app identifiers
identifier_validator = RegexValidator(
    regex='^[a-z][a-z0-9-]*[a-z0-9]$',
    message=('Identifier must contain only alphanumeric characters and hyphens. '
             'It must start with an alphabet and end with an alphanumeric character.'),
    code='invalid_identifier'
)

# Form to process application configurations
class ApplicationForm(forms.ModelForm):
    # identifer is not required as form submitted when editing an app will have this field disabled
    identifier = forms.CharField(
        min_length=3,
        max_length=16,
        required=False,
        validators=[identifier_validator])
    authenticated_routes = forms.CharField(max_length=500, required=False)
    unauthenticated_routes = forms.CharField(max_length=500, required=False)

    class Meta:
        model = Application
        fields = ['descriptive_name', 'description',
                  'authentication', 'database', 'published_on_strap']

# Form to process k8s resources updates
class K8sResourcesForm(forms.Form):
    replicas = forms.IntegerField(required=True, min_value=1, max_value=10)

# Form to process requests for more k8s resources quota
class K8sResourcesRequestForm(forms.Form):
    replicas = forms.IntegerField(required=True, min_value=1, max_value=10)
    justification = forms.CharField(max_length=500, required=False)

# Form to process container configurations
class ContainerForm(forms.ModelForm):
    is_main = forms.BooleanField(required=False)

    class Meta:
        model = Container
        exclude = ['application', 'last_updated']

# Form to process groups for applications
class GroupForm(forms.ModelForm):
    class Meta:
        model = Group
        fields = '__all__'
        exclude = ['created_by']

strapper/normal_users/views.py
# pylint:

import environ

# pylint: disable=unused-import
# NOTE: Import these classes to be imported in urls.py
from .view_classes.dashboard import Dashboard
from .view_classes.application import (ApplicationView, ApplicationDeleteView, ApplicationAPIView,
                                       ApplicationLogView, ApplicationTerminalView)
from .view_classes.k8s import K8sResourcesView, K8sResourcesRequestView
from .view_classes.container import ContainerAPIView, ContainerScanReportView, ContainerScanView
from .view_classes.harbor import HarborAPIView
from .view_classes.group import GroupView, GroupAPIView
from .view_classes.deployment import DeploymentView, DeploymentLogView, StopDeploymentView
from .view_classes.landings import WelcomeView, AboutTeam, DefaultStrapView
from .view_classes.helpers import deployment_app_info_view
from .view_classes.notification import NotificationView
# pylint: enable=unused-import

# Enable the line below if need to specify the path of .env file
environ.Env.read_env()

strapper/templates/normal_users/dashboard/app_tr.html
<tr>
  <th scope="row"><a href="{% url 'get_app' identifier=application.identifier %}">{{ application.descriptive_name }}</a></th>
  <td>{% if application.deployment %}{{ application.deployment.get_state }}{% else %}None{% endif %}</td>
  <td>{% if application.deployment.state == 2 %}<a href="{{ application.get_url }}" target="_blank">{{ application.get_url }}</a>{% else %}None{% endif %}</td>
  <td>
    {{ role|capfirst }}
    {% if role == 'owner' %}
      <i class="fa-solid fa-crown ms-1 text-warning"></i>
    {% elif role == 'editor' %}
      <i class="fa-solid fa-pen ms-1 text-success"></i>
    {% else %}
      <i class="fa-solid fa-eye ms-1 text-secondary"></i>
    {% endif %}
  </td>
  <td>{{ application.last_updated }}</td>
</tr>

strapper/templates/normal_users/dashboard/index.html
{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/dashboard.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'style/group.css' %}">
{% endblock %}
{% block title %}Dashboard{% endblock %}
{% block content %}

  <main>
    <!-- General configurations made by admin -->
    <input id="reserved-app-names" type="hidden" value="{{ general_config.reserved_app_names }}">

    <div id="received-transfer-requests-container">
      {% for transfer_request in received_transfer_requests %}
        <div class="alert alert-info w-100" role="alert">
          <i class="fa-solid fa-circle-info me-1"></i>
          <strong>{{ transfer_request.app.owner.username }}</strong> has requested to transfer the ownership of the app <strong>{{ transfer_request.app.descriptive_name }}</strong> to you.
          You still have {{ transfer_request.days_left }} days to accept or decline the request.
          <div class="mt-1">
            <a href="{% url 'access:accept_ownership_transfer_request' app_id=transfer_request.app.identifier %}" class="btn btn-primary btn-sm mt-2 transfer-ownership-accept-btn">Accept</a>
            <a href="{% url 'access:decline_ownership_transfer_request' app_id=transfer_request.app.identifier %}" class="btn btn-danger btn-sm mt-2 transfer-ownership-decline-btn">Decline</a>
          </div>
        </div>
      {% endfor %}
    </div>

    <div class="app-modal" id="apps-table">
      <div class="app-modal-header bg-dark d-flex flex-row justify-content-between"><span>Your applications</span><span><i class="fa-solid fa-plus fw-light icon-btn-light app-create-btn"></i></span></div>
      <div class="app-modal-body">
        <div class="card my-2 app-create-form">
          <div class="card-body">
            {% include 'forms/config_app.html' %}
          </div>
        </div>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">Application</th>
              <th scope="col">State</th>
              <th scope="col">URL</th>
              <th scope="col">Role</th>
              <th scope="col">Last updated</th>
            </tr>
          </thead>
          <tbody>
            {% if owned_applications or editor_applications or viewer_applications %}
                        <!-- Display all apps that this user owns -->
              {% for application in owned_applications %}
                {% with role='owner' %}
                  {% include 'normal_users/dashboard/app_tr.html' %}
                {% endwith %}
              {% endfor %}

                        <!-- Display all apps that this user is an editor of -->
              {% for application in editor_applications %}
                {% with role='editor' %}
                  {% include 'normal_users/dashboard/app_tr.html' %}
                {% endwith %}
              {% endfor %}

                        <!-- Display all apps that this user is a viewer of -->
              {% for application in viewer_applications %}
                {% with role='viewer' %}
                  {% include 'normal_users/dashboard/app_tr.html' %}
                {% endwith %}
              {% endfor %}
            {% else %}
              <tr>
                <td colspan="5" class="text-center">No application found. Please create one by clicking on the "+" button.</td>
              </tr>
            {% endif %}
          </tbody>
        </table>
      </div>
    </div>
  </main>

{% endblock %}
{% block script %}
  {% load static %}
  <script src="{% static 'js/dashboard.js' %}" type="module"></script>
{% endblock %}